package de.fhdw.wtf.common.ast.visitor;

import de.fhdw.wtf.common.ast.type.BaseType;
import de.fhdw.wtf.common.ast.type.ClassType;

/**
 * Return-Visitor for {@link de.fhdw.wtf.common.ast.type.AtomicType}.
 * 
 * @param <X>
 *            ReturnType
 */
public interface AtomicTypeVisitorReturn<X> {
	
	/**
	 * Handle-Method.
	 * 
	 * @param baseType
	 *            {@link BaseType}.
	 * @return X
	 */
	X handle(BaseType baseType);
	
	/**
	 * Handle-Method.
	 * 
	 * @param clazz
	 *            {@link ClassType}.
	 * @return X
	 */
	X handle(ClassType clazz);
}
