package de.fhdw.wtf.common.ast.visitor;

import de.fhdw.wtf.common.ast.Group;
import de.fhdw.wtf.common.ast.type.ClassType;

/**
 * Return visitor for the {@link de.fhdw.wtf.common.ast.GroupElement}.
 * 
 * @param <X>
 *            return type of this visitor
 * 
 */
public interface GroupElementReturnVisitor<X> {
	
	/**
	 * Handle operations for the type {@link Group}.
	 * 
	 * @param group
	 *            {@link Group}
	 * @return X
	 */
	X handle(Group group);
	
	/**
	 * Handle operations for the type {@link ClassType}.
	 * 
	 * @param clss
	 *            {@link ClassType}
	 * @return X
	 */
	X handle(ClassType clss);
}
