package de.fhdw.wtf.common.exception.editor;

import de.fhdw.wtf.common.token.Position;

/**
 * Interface for the Editor. If a class implements this Interface, the Editor can mark with it an area in the wtf-Model
 * and show the description.
 */
public interface EditorMarkable {
	
	/**
	 * Returns the Start-Position of the area which the editor have to mark.
	 * 
	 * @return Start-Position
	 */
	Position getStartPosition();
	
	/**
	 * Returns a description why this area is marked.
	 * 
	 * @return description
	 */
	String getDescription();
	
	/**
	 * Returns the End-Position of the area which the editor have to mark.
	 * 
	 * @return End-Position
	 */
	Position getEndPos();
	
	/**
	 * Returns the Marker.
	 * 
	 * @return Marker
	 */
	EditorMarker getMarker();
}
