package de.fhdw.wtf.common.exception.parser;

import de.fhdw.wtf.common.constants.parser.ExceptionConstants;
import de.fhdw.wtf.common.token.Token;

/**
 * {@link OperationModifierAlreadyAddedException} will be thrown, if an {@link de.fhdw.wtf.common.ast.OperationModifier}
 * add to the list of modifiers and the modifier already exists in the list.
 * 
 */
public final class OperationModifierAlreadyAddedException extends AbstractParserException {
	
	/**
	 * generated.
	 */
	private static final long serialVersionUID = -5000924926820194276L;
	
	/**
	 * Constructor of {@link OperationModifierAlreadyAddedException}.
	 * 
	 * @param token
	 *            token
	 * @param message
	 *            message
	 */
	private OperationModifierAlreadyAddedException(final Token token, final String message) {
		super(token, message);
	}
	
	/**
	 * Creates a {@link OperationModifierAlreadyAddedException}-Object.
	 * 
	 * @param token
	 *            token
	 * @return The {@link OperationModifierAlreadyAddedException}-Object.
	 */
	public static OperationModifierAlreadyAddedException create(final Token token) {
		return new OperationModifierAlreadyAddedException(token,
				ExceptionConstants.OPERATION_MODIFIER_ALREADY_ADDED_EXCEPTION);
	}
}
