package de.fhdw.wtf.common.exception.referencer;

import java.util.Collection;

import de.fhdw.wtf.common.ast.Constructor;
import de.fhdw.wtf.common.constants.referencer.ExceptionConstans;
import de.fhdw.wtf.common.token.Token;

/**
 * A Method of the {@link de.fhdw.wtf.walker.tasks.ConstructorReferencer} throws it.
 * 
 */
public final class DuplicateConstructorException extends ReferencerException {
	
	/**
	 * Constructor of {@link DuplicateConstructorException}.
	 * 
	 * @param duplicateConstructors
	 *            the duplicate constructors found.
	 * 
	 * @param token
	 *            token
	 */
	private DuplicateConstructorException(final Collection<Constructor> duplicateConstructors, final Token token) {
		super(token, ExceptionConstans.DUPLICATE_CONSTRUCOR_MESSAGE + duplicateConstructors);
	}
	
	/**
	 * Creates a {@link DuplicateConstructorException}-Object.
	 * 
	 * @param duplicateConstructors
	 *            the duplicate constructors found.
	 * @param token
	 *            token
	 * @return The {@link DuplicateConstructorException}-Object.
	 */
	public static DuplicateConstructorException create(final Collection<Constructor> duplicateConstructors,
			final Token token) {
		return new DuplicateConstructorException(duplicateConstructors, token);
	}
	
}
