package de.fhdw.wtf.tooling.editor.proposals;

import org.eclipse.jface.text.BadLocationException;
import org.eclipse.jface.text.IDocument;
import org.eclipse.jface.text.ITextViewer;

public abstract class OffsetProposal extends ContextProposal {
	
	protected OffsetProposal(final String[] proposals) {
		super(proposals);
	}
	
	@Override
	protected Integer skipToToken(final ITextViewer viewer, final int offset) {
		final IDocument document = viewer.getDocument();
		int documentOffset = offset;
		while (true) {
			char c;
			try {
				if (documentOffset > 0) {
					c = document.getChar(--documentOffset);
					if (c == '{' || c == '[') {
						throw new BadLocationException();
					}
					if (Character.isWhitespace(c)) {
						final char expectedSymbol = document.getChar(--documentOffset);
						if (this.checkForExpectedSymbole(expectedSymbol)) {
							return documentOffset;
						} else {
							return null;
						}
					}
				} else {
					return null;
				}
				
			} catch (final BadLocationException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
	}
	
	protected abstract boolean checkForExpectedSymbole(char expectedSymbol);
	
}
